Bug 609154 - Facility to fetch rhq:archive and rhq:file over an URL
Facility to fetch rhq:archive and rhq:file over an URL
Status: CLOSED CURRENTRELEASE
Product: RHQ Project
Classification: Other
Component: Provisioning (Show other bugs)
3.0.0
All All
high Severity medium (vote)
: ---
: ---
Assigned To: John Mazzitelli
Mike Foley
:
: 610876 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-06-29 10:25 EDT by Shashin Shinde
Modified: 2013-09-02 03:19 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-09-02 03:19:06 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Test recipe (1.41 KB, text/xml)
2011-06-14 06:13 EDT, Sunil Kondkar
no flags Details

  None (edit)
Description Shashin Shinde 2010-06-29 10:25:34 EDT
Description of problem:

Extend rhq:archive and rhq:file tasks to allow fetching them over an URL.
That way, there is no need upload files to RHQ server for using provisioning feature.

Use Case: Provision JBoss Application Server

A customized JBoss AS binary can be uploaded to a central repository ( may be as simple as Apache HTTP server or even Subversion ).
This can then be used to provision JBoss AS on various platforms using the same file from central repository.

Different deployment tasks like provisioning of JBoss AS with default profile, with clustered profile or a stripped down profile can use the same file via URL.
Comment 1 Corey Welton 2010-09-30 09:36:51 EDT
 mazz/jshaughn - do we support, and if not, what would it take?
Comment 2 John Mazzitelli 2010-09-30 09:47:30 EDT
I actually have a branch locally on my box where I started this work. It isn't close to being complete, though. Its doable, its just finding time to do it. Less than a week worth of work I'm guessing.
Comment 3 John Mazzitelli 2010-12-13 13:12:07 EST
bug 610876 duplicated this issue. Here's my comments from that dup'ed issue (which I will close to leave only this issue open).

---

some ant recipe's might not want bundle files stored in RHQ uploaded by a user.
There might be bundle files that already exist in a user's existing
infrastructure (like a apache server or a code repository) accessible via a
URL.

Be able to specify in the recipe archive and raw files that come from a URL. Be
able to have ${var} notation in the URL.

example:

<rhq:deployment-unit>
    <rhq:url-file url="http://foo/${user.config.prop}.properties"
                  destinationFile="subdir/${user.config.prop}.properties"
                  replace="true"/> 
    <rhq:url-archive url="http://${server.host.prop}/file.zip">
    ...

Notice that <rhq:url-file> has the same semantics as <rhq:file> - with the name
attribute replaced with a "url" attribute - it just gets the content of the
file from the URL rather than the local disk at ${basedir}.

Notice that <rhq:url-archive> has the same semantics as <rhq:archive> - with
the name attribute replaced with a "url" attribute - it just gets the content
of the archive from the URL rather than the local disk at ${basedir}.

An optional further enhancement would be to support credentials of the URL is
secured.

Would probably also need to support this kind of feature in the file template recipe type, though not as critical.
Comment 4 John Mazzitelli 2010-12-13 13:12:39 EST
*** Bug 610876 has been marked as a duplicate of this bug. ***
Comment 5 John Mazzitelli 2010-12-13 13:13:56 EST
I have the start of this on my local box... though it isn't close to complete.
Comment 6 John Mazzitelli 2010-12-14 11:40:55 EST
this is important to implement for those people that have large bundles that they don't want stored in RHQ's own data store. The bundles might already exist somewhere else (in some git repo, or apache server, as two examples) - they just want to use that rather store duplicates in RHQ.

(note to self: can we use content sources for this? just a thought)
Comment 7 John Mazzitelli 2010-12-24 00:13:21 EST
master commit: 9f09183904e6c03dc81b058f715a12ce02bc662c

for docs on how to put this in your ant recipe and test, see:

http://rhq-project.org/display/JOPR2/Ant+Bundles#AntBundles-rhq%3Aurlarchive
http://rhq-project.org/display/JOPR2/Ant+Bundles#AntBundles-rhq%3Aurlfile
Comment 8 Sunil Kondkar 2011-06-14 06:12:15 EDT
Verified on build#123 (Version: 4.1.0-SNAPSHOT Build Number: a6d2d56)

Created a recipe with rhq:url-file url and rhq:url-archive url tasks to allow fetching them over an URL. Please refer the attached recipe.

Created and deployed the bundle successfully.

Marking as verified.
Comment 9 Sunil Kondkar 2011-06-14 06:13:32 EDT
Created attachment 504641 [details]
Test recipe
Comment 10 Heiko W. Rupp 2013-09-02 03:19:06 EDT
Bulk closing of issues that were VERIFIED, had no target release and where the status changed more than a year ago.

Note You need to log in before you can comment on or make changes to this bug.